#------------------------------------------------------------
# file: gdoor_cmd_module.py
# date: 1-29-2020
#------------------------------------------------------------
# Garage door commands module for garage.py
# Operate Door and Light
#------------------------------------------------------------
import RPi.GPIO as GPIO
import time

#------------------------------------------------------------
# OUTPUTS: (GPO)
#------------------------------------------------------------
Operate_Door_CMD = 24   # wired to spare remote
Door_Light_CMD = 25     # wired to spare remote
Operate_Light_LED = 26
Operate_Door_LED = 6
Door_is_Down_LED = 5
Door_is_Up_LED = 22

#------------------------------------------------------------
# INPUTS: (GPI)
#------------------------------------------------------------
Door_Position = 16  # 1=Open, 0=Closed

#------------------------------------------------------------
# Define Global Variables
#------------------------------------------------------------
global dopen, dclose, ls_open, ls_close
global web_cmd
#------------------------------------------------------------
# Initialize Global Variables
#------------------------------------------------------------
dopen=0
dclose=0
ls_open=0
ls_close=0
web_cmd=0
         
#------------------------------------------------------------
def Check_Door_Operate_Command(dt_string):
#------------------------------------------------------------
     web_cmd = Check_Web_Site_Commands_File()
     if (web_cmd=="1"):
        Door_Operate_Command(dt_string)
        Clear_Web_Site_Commands_File()
        
#------------------------------------------------------------
def Check_Door_Light_Command(dt_string):
#------------------------------------------------------------
     web_cmd = Check_Web_Site_Commands_File()
     if (web_cmd=="2"):
        Door_Light_Command(dt_string)
        Clear_Web_Site_Commands_File()
        
#------------------------------------------------------------
# Send Output Commands
#------------------------------------------------------------
def Door_Operate_Command(dt_string):
#------------------------------------------------------------
    message = dt_string + " Door Operate CMD - ON"
    Write_Door_Activity_file(message)
    GPIO.output(Operate_Door_CMD,1)
    GPIO.output(Operate_Door_LED,1)
    print(message)
    time.sleep(2)
    GPIO.output(Operate_Door_CMD,0)
    GPIO.output(Operate_Door_LED,0)
    message = dt_string + " Door Operate CMD - OFF"
    Write_Door_Activity_file(message)

#------------------------------------------------------------
def Door_Light_Command(dt_string):
#------------------------------------------------------------
    if (GPIO.input(Operate_Light_LED)==1):
        message = dt_string + " Door Light OFF CMD"
        Write_Door_Activity_file(message)
        GPIO.output(Door_Light_CMD,1)
        GPIO.output(Operate_Light_LED,0)
        time.sleep(2)
        GPIO.output(Door_Light_CMD,0)
        print(message)
    else:
        message = dt_string + " Door Light ON CMD"
        Write_Door_Activity_file(message)
        GPIO.output(Door_Light_CMD,1)
        GPIO.output(Operate_Light_LED,1)
        time.sleep(2)
        GPIO.output(Door_Light_CMD,0)
        print(message)

#------------------------------------------------------------
# Check Inputs
#------------------------------------------------------------
def Check_Door_Position(dt_string):
#------------------------------------------------------------
    global dopen,dclose,ls_open,ls_close
    if (GPIO.input(Door_Position) == True):
        ls_close=0
        dclose=0
        ls_open=ls_open+1
        
    if (GPIO.input(Door_Position) == False):
        ls_open=0
        dopen=0
        ls_close=ls_close+1
        
     #Door_Stat = GPIO.input(Door_Position)  # Returns 0 if OFF or 1 if ON
    if (ls_open >=10 and dopen==0):
        ls_open=10
        ls_close=0
        dopen=1
        # if GPIO.input(Door_Position) == False: # Returns 0 if OFF or 1 if ON:
        message = dt_string + " Door Limit = Open"
        Write_Door_Activity_file(message)
        Update_Web_Site_file(message)
        GPIO.output(Door_is_Up_LED,1)
        GPIO.output(Door_is_Down_LED,0)
        print(dt_string, " Door Limit = Open")
        
    if (ls_close >=10 and dclose==0):
        ls_close=10
        ls_open=0
        dclose=1
        message = dt_string + " Door Limit = Closed"
        Write_Door_Activity_file(message)
        Update_Web_Site_file(message)
        GPIO.output(Door_is_Down_LED,1)
        GPIO.output(Door_is_Up_LED,0)
        print(dt_string, " Door Limit = Closed")

#------------------------------------------------------------
def Write_Door_Activity_file(message):
#------------------------------------------------------------
    f = open("/home/pi/projects/garage/door_activity/current_door_activity.log",'a+')
    f.write(message)
    f.write("\n")
    f.close()
#------------------------------------------------------------
def Update_Web_Site_file(message):
#------------------------------------------------------------
    f = open("/var/www/html/door_active.txt",'w')
    f.write(message)
    f.write("\n")
    f.close()
#------------------------------------------------------------
def Check_Web_Site_Commands_File():
#------------------------------------------------------------
    f = open("/var/www/html/web_cmd.txt",'r')
    web_cmd = f.readline()
    f.close()
    return web_cmd
#------------------------------------------------------------
def Clear_Web_Site_Commands_File():
#------------------------------------------------------------
    f = open("/var/www/html/web_cmd.txt",'w')
    f.write("0")
    f.close()
#------------------------------------------------------------
if __name__ == '__main__':
    main()


