#------------------------------------------------------------
# file: temp_module.py
# date: 1-29-2020
#------------------------------------------------------------
# DS18B20 temp module for garage.py
#------------------------------------------------------------
import os
import glob 
import time
os.system('modprobe w1-gpio') 
os.system('modprobe w1-therm')

#------------------------------------------------------------ 
base_dir = '/sys/bus/w1/devices/' 
device_folder = glob.glob(base_dir + '28*')[0] 
device_file = device_folder + '/w1_slave'

# INPUTS (GPI)
Garage_Temp = 4     # DS18B20 temp sensor

#------------------------------------------------------------
global temp_f
global t10s,t1min,t10sec_data,t60sec_data,t60min_data,t1min_data

#------------------------------------------------------------
t10s=0
t1min=0
t10sec_data=0
t60sec_data=0
t60min_data=0
t1min_data=0
temp_f=0

#------------------------------------------------------------
def read_temp():
#------------------------------------------------------------
    global temp_f
    f = open(device_file, 'r') 
    lines = f.readlines() 
    f.close()
    
    while lines[0].strip()[-3:] != 'YES':
        time.sleep(0.2)
        lines = read_temp_raw() 
    equals_pos = lines[1].find('t=')
    if equals_pos != -1:
        temp_string = lines[1][equals_pos+2:] 
        temp_c = float(temp_string) / 1000.0 
        temp_f = temp_c * 9.0 / 5.0 + 32.0
        return

#------------------------------------------------------------
def Write_temp_file(dt_string):
#------------------------------------------------------------
    global t10s,t1min,t10sec_data,t60sec_data,t60min_data
    global t1min_data
    global temp_f
    temp_f_string = str("{:.2f}".format(temp_f))
    message = dt_string + "  " + temp_f_string
#    print (message)
    Update_Web_Site_file(temp_f_string)
    
    t10s=t10s+1
    # temp_10sec = 10 sec update
    if (t10s <= 6):
        f = open("/home/pi/projects/garage/temp_data/temp_10sec.dat",'a')
        f.write(message)
        f.write("\n")
        f.close()
        t10sec_data = t10sec_data + temp_f
 #       print (t10s)
 #       print (t10sec_data)
        
    # temp_1min = 1 min update =  10 second data samples
    if (t10s >= 6):
        t60sec_data = t10sec_data/6
        temp_f_string = str("{:.2f}".format(t60sec_data))
        #temp_f_string = str(t60sec_data)
        message = dt_string + "  " + temp_f_string
        f = open("/home/pi/projects/garage/temp_data/temp_1min.dat",'a')
        f.write(message)
        f.write("\n")
        f.close()
        t1min_data = t60sec_data + t1min_data
        t10s=0
        t1min=t1min + 1
        t10sec_data=0
        # Delete file
        if os.path.exists("/home/pi/projects/garage/temp_data/temp_10sec.dat"):
            os.remove("/home/pi/projects/garage/temp_data/temp_10sec.dat")

    # temp_1hr = 1 hour update
    if (t1min >= 60):
        t60min_data = t1min_data/60
        temp_f_string = str("{:.2f}".format(t60min_data))
        #temp_f_string = str(t60min_data)
        message = dt_string + "  " + temp_f_string        
        f = open("/home/pi/projects/garage/temp_data/temp_1hr.dat",'a')
        f.write(message)
        f.write("\n")
        f.close()
        t1min = 0
        t1min_data = 0
        if os.path.exists("/home/pi/projects/garage/temp_data/temp_1min.dat"):
            #os.remove("/home/pi/projects/garage/temp_data/temp_1min.dat")
            open('/home/pi/projects/garage/temp_data/temp_1min.dat', 'w').close()
#------------------------------------------------------------
def Update_Web_Site_file(message):
#------------------------------------------------------------
    f = open("/var/www/html/garage_temperature.txt",'w')
    f.write(message)
    f.write("\n")
    f.close()
#------------------------------------------------------------
if __name__ == '__main__':
    main()


