#------------------------------------------------------------
# file: wdt.py
# date: 1-10-2020
#------------------------------------------------------------
# Pulse LED to indicate PI board ok and software running.
# for garage.py project.
#------------------------------------------------------------
import RPi.GPIO as GPIO
import time

#---------------------------------------------
# Pin Definitions
#---------------------------------------------
WDT_led = 23
Recieve_Data_LED = 17
Send_Data_LED = 27

#---------------------------------------------
# Suppress Warnings
#---------------------------------------------
GPIO.setwarnings(False)
#---------------------------------------------
# Use GPIO pin numbering
#---------------------------------------------
GPIO.setmode(GPIO.BCM)
#---------------------------------------------
# Set Outputs
#---------------------------------------------
GPIO.setup(WDT_led,GPIO.OUT)
pwm = GPIO.PWM(WDT_led, 100)
pwm.start(0)

GPIO.setup(Recieve_Data_LED,GPIO.OUT)
GPIO.setup(Send_Data_LED,GPIO.OUT)
GPIO.output(Recieve_Data_LED,0)
GPIO.output(Send_Data_LED,0)

#---------------------------------------------
# Variables
#---------------------------------------------
global wdtled
wdtled=0
#---------------------------------------------
# Routines
#---------------------------------------------
def wdt():
    dc=0
    for dc in range(0,101,5):
        pwm.ChangeDutyCycle(dc)
        time.sleep(0.05)
    for dc in range(95,0,-5):
        pwm.ChangeDutyCycle(dc)
        time.sleep(0.05)

def web_wdt():
    global wdtled
    web_cmd = Check_Web_Site_Commands_File()
    if (web_cmd=="99"):
        wdtled = wdtled + 1 # time to update web page to see leds.
        GPIO.output(Recieve_Data_LED,1)
        time.sleep(.05)
        GPIO.output(Send_Data_LED,0)
        GPIO.output(Recieve_Data_LED,0)
        time.sleep(.05)
        GPIO.output(Send_Data_LED,1)
        time.sleep(.05)
        GPIO.output(Send_Data_LED,0)
        if (wdtled > 5):
            Clear_Web_Site_Commands_File()
            wdtled=0

#------------------------------------------------------------
def Check_Web_Site_Commands_File():
#------------------------------------------------------------
    f = open("/var/www/html/web_wdt.txt",'r')
    web_cmd = f.readline()
    f.close()
    return web_cmd

#------------------------------------------------------------
def Clear_Web_Site_Commands_File():
#------------------------------------------------------------
    f = open("/var/www/html/web_wdt.txt",'w')
    f.write("0")
    f.close()
    
#---------------------------------------------
# MAIN
#---------------------------------------------
try:
    while(True):
        wdt()
        web_wdt()

finally:
        GPIO.cleanup() # this ensures a clean exit  

#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/    